<template>
  <page>
    <a-collapse
      v-if="partners.length > 0 && !fetching"
      v-model="activeKey"
    >
      <a-collapse-panel
        v-for="(item, i) in partners"
        :key="`${i}`"
        :header="item.name"
      >
        <a-timeline>
          <a-timeline-item v-if="item.link">
            <strong>Link: </strong><a :href="item.link">{{ item.link }}</a>
          </a-timeline-item>

          <a-timeline-item>
            <strong>Foto:</strong>
            <div>
              <img
                :src="item.logo"
                :alt="`Foto do ${item.name}`"
              >
            </div>
          </a-timeline-item>

          <a-timeline-item>
            <strong>Ações: </strong>
            <div class="actions">
              <a-popconfirm
                title="Tem certeza que deseja deletar?"
                ok-text="Sim. Quero deletar."
                cancel-text="Não"
                @confirm="deletePartner(item._id)"
              >
                <a-button
                  type="danger"
                  icon="delete"
                  :disabled="deleting"
                >
                  <span v-if="deleting">
                    <a-icon type="loading" />
                  </span>
                  <span v-else>Deletar</span>
                </a-button>
              </a-popconfirm>
            </div>
          </a-timeline-item>
        </a-timeline>
      </a-collapse-panel>
    </a-collapse>

    <no-data v-if="partners.length === 0 && !fetching">
      Nenhum parceiro foi cadastrado no sistema
    </no-data>

    <page-loading v-if="fetching" />
  </page>
</template>

<script>
export default {
  name: 'Partner',
  data() {
    return {
      partners: [],
      deleting: false,
      fetching: false,
    };
  },
  async created() {
    try {
      this.fetching = true;
      const fetch = await this.$http.get('/partners');
      this.partners = fetch.data;
      this.fetching = false;
    } catch (error) {
      this.fetching = false;
      this.$message.error('Ocorreu um erro ao tentar buscar os parceiros. Tente novamente mais tarde.');
    }
  },
  methods: {
    async deletePartner(id) {
      try {
        this.deleting = true;
        await this.$http.delete(`/partners/${id}`);
        this.updatePartnersById(id);
        this.$message.success('Parceiro deletado com sucesso');
        this.deleting = false;
      } catch (error) {
        this.deleting = false;
        this.$message.error('Ocorreu um erro ao deletar o parceiro. Tente novamente mais tarde.');
      }
    },
    updatePartnersById(id) {
      // eslint-disable-next-line no-underscore-dangle
      this.partners = this.partners.filter(partner => partner._id !== id);
    },
  },
};
</script>

<style lang="stylus" scoped>
.ant-timeline-item-last
  padding 0

.actions
  margin-top 1rem

  .ant-btn-primary
    margin-right 2rem
</style>
